// src/utils/cookies.ts
function getCookie(name) {
  const crossmintRefreshToken = document.cookie.split("; ").find((row) => row.startsWith(name));
  return crossmintRefreshToken ? crossmintRefreshToken.split("=")[1] : void 0;
}
function setCookie(name, value, expiresAt) {
  const expiresInUtc = expiresAt ? new Date(expiresAt).toUTCString() : "";
  document.cookie = `${name}=${value}; ${expiresAt ? `expires=${expiresInUtc};` : ""} path=/; SameSite=Lax;`;
}
function deleteCookie(name) {
  document.cookie = `${name}=; expires=Thu, 01 Jan 1970 00:00:00 UTC; path=/;`;
}

export {
  getCookie,
  setCookie,
  deleteCookie
};
//# sourceMappingURL=chunk-5JXPQKM4.js.map