"use strict";Object.defineProperty(exports, "__esModule", {value: true});

var _chunkTIUX4OOQcjs = require('./chunk-TIUX4OOQ.cjs');




var _chunkBGMXXFQ4cjs = require('./chunk-BGMXXFQ4.cjs');


var _chunkQY4RIGNMcjs = require('./chunk-QY4RIGNM.cjs');




var _chunkF45I5NLIcjs = require('./chunk-F45I5NLI.cjs');

// src/CrossmintAuthClient.ts







var _commonsdkauth = require('@crossmint/common-sdk-auth');
var _clientsdkbase = require('@crossmint/client-sdk-base');
var CrossmintAuthClient = class _CrossmintAuthClient extends _commonsdkauth.CrossmintAuth {
  constructor(crossmint, apiClient, config = {}) {
    var _a, _b;
    super(crossmint, apiClient, config);
    this.refreshTask = null;
    this.refreshPromise = null;
    this.callbacks = (_a = config.callbacks) != null ? _a : {};
    this.logoutRoute = (_b = config.logoutRoute) != null ? _b : null;
  }
  static from(crossmint, config = {}) {
    const authClient = new _CrossmintAuthClient(crossmint, _commonsdkauth.CrossmintAuth.defaultApiClient(crossmint), config);
    if (typeof window !== "undefined") {
      authClient.handleRefreshAuthMaterial();
    }
    return authClient;
  }
  getUser() {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      try {
        const response = yield this.apiClient.get(`api/${_commonsdkauth.CROSSMINT_API_VERSION}/sdk/auth/user`, {
          headers: { "Content-Type": "application/json" }
        });
        if (!response.ok) {
          throw yield response.text();
        }
        return yield response.json();
      } catch (error) {
        throw new (0, _commonsdkauth.CrossmintAuthenticationError)(
          `Failed to fetch user: ${error instanceof Error ? error.message : "Unknown error"}`
        );
      }
    });
  }
  storeAuthMaterial(authMaterial) {
    _chunkBGMXXFQ4cjs.setCookie.call(void 0, _commonsdkauth.SESSION_PREFIX, authMaterial.jwt);
    _chunkBGMXXFQ4cjs.setCookie.call(void 0, _commonsdkauth.REFRESH_TOKEN_PREFIX, authMaterial.refreshToken.secret, authMaterial.refreshToken.expiresAt);
  }
  logout() {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      var _a, _b;
      const oldRefreshToken = _chunkBGMXXFQ4cjs.getCookie.call(void 0, _commonsdkauth.REFRESH_TOKEN_PREFIX);
      _chunkBGMXXFQ4cjs.deleteCookie.call(void 0, _commonsdkauth.REFRESH_TOKEN_PREFIX);
      _chunkBGMXXFQ4cjs.deleteCookie.call(void 0, _commonsdkauth.SESSION_PREFIX);
      (_b = (_a = this.callbacks).onLogout) == null ? void 0 : _b.call(_a);
      try {
        if (this.logoutRoute != null) {
          yield this.logoutFromCustomRoute();
        } else if (oldRefreshToken != null) {
          yield this.logoutFromDefaultRoute(oldRefreshToken);
        }
      } catch (error) {
        console.error(error);
      }
    });
  }
  handleRefreshAuthMaterial(refreshTokenSecret) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      var _a, _b;
      const refreshToken = refreshTokenSecret != null ? refreshTokenSecret : _chunkBGMXXFQ4cjs.getCookie.call(void 0, _commonsdkauth.REFRESH_TOKEN_PREFIX);
      if (refreshToken == null && this.refreshRoute == null) {
        return;
      }
      try {
        if (this.refreshPromise == null) {
          this.refreshPromise = this.refreshAuthMaterial(refreshToken);
        }
        const authMaterial = yield this.refreshPromise;
        if (this.refreshRoute == null) {
          this.storeAuthMaterial(authMaterial);
        }
        (_b = (_a = this.callbacks).onTokenRefresh) == null ? void 0 : _b.call(_a, authMaterial);
        this.scheduleNextRefresh(authMaterial.jwt);
      } catch (error) {
        console.error(error);
        this.logout();
      } finally {
        this.refreshPromise = null;
      }
    });
  }
  getOAuthUrl(provider) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      try {
        const response = yield this.apiClient.get(`${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/social/${provider}/start`, {
          headers: { "Content-Type": "application/json" }
        });
        if (!response.ok) {
          throw yield response.text();
        }
        const data = yield response.json();
        return data.oauthUrl;
      } catch (error) {
        throw new (0, _commonsdkauth.CrossmintAuthenticationError)(
          `Failed to get OAuth URL for provider ${provider}: ${error instanceof Error ? error.message : "Unknown error"}`
        );
      }
    });
  }
  sendEmailOtp(email) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      try {
        const response = yield this.apiClient.post(`${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/otps/send`, {
          headers: { "Content-Type": "application/json" },
          body: JSON.stringify({ email })
        });
        if (!response.ok) {
          throw yield response.text();
        }
        return yield response.json();
      } catch (error) {
        throw new (0, _commonsdkauth.CrossmintAuthenticationError)(
          `Failed to send email OTP: ${error instanceof Error ? error.message : "Unknown error"}`
        );
      }
    });
  }
  confirmEmailOtp(email, emailId, token) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      try {
        const queryParams = new URLSearchParams({
          email,
          signinAuthenticationMethod: "email",
          token,
          locale: "en",
          state: emailId
        });
        const response = yield this.apiClient.post(`${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/authenticate?${queryParams}`, {
          headers: { "Content-Type": "application/json" }
        });
        if (!response.ok) {
          throw yield response.text();
        }
        const resData = yield response.json();
        return resData.oneTimeSecret;
      } catch (error) {
        throw new (0, _commonsdkauth.CrossmintAuthenticationError)(
          `Failed to confirm email OTP: ${error instanceof Error ? error.message : "Unknown error"}`
        );
      }
    });
  }
  signInWithFarcaster(data) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      try {
        const queryParams = new URLSearchParams({
          signinAuthenticationMethod: "farcaster",
          callbackUrl: `${this.apiClient.baseUrl}/${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/callback`
        });
        const response = yield this.apiClient.post(`${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/authenticate?${queryParams}`, {
          headers: { "Content-Type": "application/json" },
          body: JSON.stringify(_chunkF45I5NLIcjs.__spreadProps.call(void 0, _chunkF45I5NLIcjs.__spreadValues.call(void 0, {}, data), {
            domain: data.signatureParams.domain,
            redirect: true,
            callbackUrl: `${this.apiClient.baseUrl}/${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/callback`
          }))
        });
        if (!response.ok) {
          throw yield response.text();
        }
        const resData = yield response.json();
        return resData.oneTimeSecret;
      } catch (error) {
        throw new (0, _commonsdkauth.CrossmintAuthenticationError)(
          `Failed to sign in with Farcaster: ${error instanceof Error ? error.message : "Unknown error"}`
        );
      }
    });
  }
  signInWithSmartWallet(address) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      try {
        const queryParams = new URLSearchParams({ signinAuthenticationMethod: "evm" });
        const response = yield this.apiClient.post(
          `${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/crypto_wallets/authenticate/start?${queryParams}`,
          {
            headers: { "Content-Type": "application/json" },
            body: JSON.stringify({ walletAddress: address })
          }
        );
        if (!response.ok) {
          throw yield response.text();
        }
        return yield response.json();
      } catch (error) {
        throw new (0, _commonsdkauth.CrossmintAuthenticationError)(
          `Failed to initiate smart wallet sign in: ${error instanceof Error ? error.message : "Unknown error"}`
        );
      }
    });
  }
  authenticateSmartWallet(address, signature) {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      try {
        const queryParams = new URLSearchParams({
          signinAuthenticationMethod: "evm",
          callbackUrl: `${this.apiClient.baseUrl}/${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/callback`
        });
        const response = yield this.apiClient.post(
          `${_commonsdkauth.AUTH_SDK_ROOT_ENDPOINT}/crypto_wallets/authenticate?${queryParams}`,
          {
            headers: { "Content-Type": "application/json" },
            body: JSON.stringify({ walletAddress: address, signature })
          }
        );
        if (!response.ok) {
          throw yield response.text();
        }
        return yield response.json();
      } catch (error) {
        throw new (0, _commonsdkauth.CrossmintAuthenticationError)(
          `Failed to authenticate smart wallet: ${error instanceof Error ? error.message : "Unknown error"}`
        );
      }
    });
  }
  logoutFromCustomRoute() {
    return _chunkF45I5NLIcjs.__async.call(void 0, this, null, function* () {
      if (!this.logoutRoute) {
        throw new Error("Custom logout route is not set");
      }
      return yield fetch(this.logoutRoute, { method: "POST" });
    });
  }
  scheduleNextRefresh(jwt) {
    const jwtExpiration = _chunkQY4RIGNMcjs.getJWTExpiration.call(void 0, jwt);
    if (!jwtExpiration) {
      throw new Error("Invalid JWT");
    }
    const currentTime = Date.now() / 1e3;
    const timeToExpire = jwtExpiration - currentTime - _chunkTIUX4OOQcjs.TIME_BEFORE_EXPIRING_JWT_IN_SECONDS;
    if (timeToExpire > 0) {
      const endTime = Date.now() + timeToExpire * 1e3;
      this.cancelScheduledRefresh();
      this.refreshTask = _clientsdkbase.queueTask.call(void 0, () => this.handleRefreshAuthMaterial(), endTime);
    }
  }
  cancelScheduledRefresh() {
    if (this.refreshTask) {
      this.refreshTask.cancel();
      this.refreshTask = null;
    }
  }
};



exports.CrossmintAuthClient = CrossmintAuthClient;
//# sourceMappingURL=chunk-FEGDFSUW.cjs.map